/**************************************************************************/
/*      表を挿入...のダイアログを横取り！　罫線を指定して表を作成         */
/*                                                           by お～まち  */
/*                                              2009.04.30  Version 1.11  */
/**************************************************************************/
#targetengine "session"
app.scriptPreferences.userInteractionLevel=UserInteractionLevels.interactWithAll;
var menuA = app.menuActions.item("$ID/Insert Table...");
var eventB = menuA.eventListeners.add("beforeInvoke", main, false);

function main(){
	Make_Table_With_StrokeStyle (app.selection[0]);
	//選択を解除（文字カーソルを立てない状態にする）することで
	//本来のダイアログが機能しない（グレーアウト）ようにしている
	//本当はどうすべきなの？
	app.select(1851876449);
}

//以下、TablewithStroke.js と同じ
function Make_Table_With_StrokeStyle (ip) {
	var doc = app.activeDocument;
	switch (doc.viewPreferences.lineMeasurementUnits) {
		case 2053729891 : uns = 1; break; //インチ
		case 2053991795 : uns = 2; break; //ミリメートル
		case 2053336435 : uns = 3; break; //センチメートル
		case 1516790048 : uns = 4; break; //歯
		case 1514238068 : uns = 5; break; //アメリカ式ポイント
		default : uns = 0;
	}
	//ダイアログの準備
	var sc = new Array(); //スウォッチの配列
	var sd = new Array(); //スウォッチの表示用名称の配列
	for (i = 0 ; i < doc.swatches.length ; i++) {
		sc[i] = doc.swatches[i];
		switch (sc[i].name) {
			case "None"         : sd[i] = "[なし]"; break;
			case "Paper"        : sd[i] = "[紙色]"; break;
			case "Black"        : sd[i] = "[黒]"; scs = i; break;
			case "Registration" : sd[i] = "[レジストレーション]"; break;
			default:sd[i] = sc[i].name;
		}
	}
	var ss = new Array(); //線種の配列
	var st = new Array(); //線種の名称の配列
	for (i = 0 ; i < doc.strokeStyles.length ; i++) {
		ss[i] = doc.strokeStyles[i];
		st[i] = ss[i].name;
		if (st[i] == "ベタ") sss = i;
	}
	var ts = new Array(); //表スタイルの配列
	var tt = new Array(); //表スタイルの名称の配列
	for (i = 0 ; i < doc.tableStyles.length ; i++) {
		ts[i] = doc.tableStyles[i];
		tt[i] = ts[i].name;
		if (tt[i] == "[基本表]") tss = i;
	}
	var un = ["ポイント", "インチ", "ミリメートル", "センチメートル", "歯", "アメリカ式ポイント"];
	var ux = [1, 72, 2.83465, 28.3465, 0.7087, 0.996];
	//ダイアログ作成
	dlg = app.dialogs.add({name:"表を挿入（罫線指定つき）"});
	dlc = dlg.dialogColumns.add();
	with(dlc.dialogRows.add()){ //1行目
		staticTexts.add({staticLabel:"表の設定　　　　表スタイル"});
		tstyle = dropdowns.add({stringList:tt, selectedIndex:tss});
	}
	with(dlc.dialogRows.add()){ //2・3行目
		with(dialogColumns.add()){
			staticTexts.add({staticLabel:"本文行："});
			staticTexts.add({staticLabel:"列："});
		}
		with(dialogColumns.add()){
			var tr = integerEditboxes.add({minimumValue:1, maximumValue:255, minWidth:80, editValue:4});
			var tc = integerEditboxes.add({minimumValue:1, maximumValue:255, minWidth:80, editValue:4});
		}
		with(dialogColumns.add()){
			staticTexts.add({staticLabel:"　ヘッダ行："});
			staticTexts.add({staticLabel:"　フッタ行："});
		}
		with(dialogColumns.add()){
			var th = integerEditboxes.add({minimumValue:0, maximumValue:255, minWidth:80, editValue:0});
			var tf = integerEditboxes.add({minimumValue:0, maximumValue:255, minWidth:80, editValue:0});
		}
	}
	with(dlc.dialogRows.add()){staticTexts.add({staticLabel:" "})};
	dlk = dlc.enablingGroups.add({staticLabel:"スタイルとは別に罫線を指定", checkedState:false});
	dlb = dlk.dialogColumns.add();
	with(dlb.dialogRows.add()){ //1行目
		staticTexts.add({staticLabel:"太さの単位："});
		wut = dropdowns.add({stringList:un, selectedIndex:uns});
	}
	with(dlb.dialogRows.add()){ //2行目
		staticTexts.add({staticLabel:"外枠："});
		ss0 = dropdowns.add({stringList:st, selectedIndex:sss}); //線種
		sw0 = realEditboxes.add({minWidth:60, minimumValue:0.004, maximumValue:100, editValue:0.25}); //太さ
		sc0 = dropdowns.add({stringList:sd, selectedIndex:scs}); //色
	}
	with(dlb.dialogRows.add()){ //3行目
		staticTexts.add({staticLabel:"内部："});
		ss1 = dropdowns.add({stringList:st, selectedIndex:sss}); //線種
		sw1 = realEditboxes.add({minWidth:60, minimumValue:0.004, maximumValue:100, editValue:0.12}); //太さ
		sc1 = dropdowns.add({stringList:sd, selectedIndex:scs}); //色
	}
	with(dlb.dialogRows.add()){staticTexts.add({staticLabel:" "})};
	//4行目
	ck2 = dlb.enablingGroups.add({staticLabel:"本文行とヘッダ行の境界", checkedState:false});
	ss2 = ck2.dropdowns.add({stringList:st, selectedIndex:sss}); //線種
	sw2 = ck2.realEditboxes.add({minWidth:80, minimumValue:0.004, maximumValue:100, editValue:0.25}); //太さ
	sc2 = ck2.dropdowns.add({stringList:sd, selectedIndex:scs}); //色
	//5行目
	ck3 = dlb.enablingGroups.add({staticLabel:"本文行とフッタ行の境界", checkedState:false});
	ss3 = ck3.dropdowns.add({stringList:st, selectedIndex:sss}); //線種
	sw3 = ck3.realEditboxes.add({minWidth:80, minimumValue:0.004, maximumValue:100, editValue:0.25}); //太さ
	sc3 = ck3.dropdowns.add({stringList:sd, selectedIndex:scs}); //色
	//6行目
	ck4 = dlb.enablingGroups.add({staticLabel:"列指定", checkedState:false});
	dlb = ck4.dialogColumns.add();
	with(dlb.dialogRows.add()){
		ckc = integerEditboxes.add();
		staticTexts.add({staticLabel:"列目の右（下）"});
	}
	with(dlb.dialogRows.add()){
		ss4 = dropdowns.add({stringList:st, selectedIndex:sss}); //線種
		sw4 = realEditboxes.add({minWidth:80, minimumValue:0.004, maximumValue:100, editValue:0.25}); //太さ
		sc4 = dropdowns.add({stringList:sd, selectedIndex:scs}); //色
	}
	//ダイアログの表示と値のチェック
	var err_flag = true;
	while(err_flag == true){
		if(dlg.show() == false){ dlg.destroy(); return; }
		err_flag = false;
		if (tc.editValue < 1){alert("列数が1以下です");err_flag = true;}
		if (tr.editValue < 1){alert("行数が1以下です");err_flag = true;}
		if (ck4.checkedState) {
			if (ckc.editValue < 1) {
				alert("列指定の列番号が1以下です");
				err_flag = true;
			} else if (ckc.editValue >= tc.editValue) {
				alert("列指定の列番号が列数以上です");
				err_flag = true;
			}
		}
	}
	//単位をポイントに変更
	uni = new Array();
	with (doc.viewPreferences){
		uni[0] = horizontalMeasurementUnits;
		uni[1] = verticalMeasurementUnits;
		uni[2] = lineMeasurementUnits;
		uni[3] = textSizeMeasurementUnits;
		uni[4] = typographicMeasurementUnits;
		horizontalMeasurementUnits = 2054188905;
		verticalMeasurementUnits = 2054188905;
		lineMeasurementUnits = 2054188905;
		textSizeMeasurementUnits = 2054188905;
		typographicMeasurementUnits = 2054188905;
	}
	//表の作成
	var tbl = ip.tables.add();
	tbl.columnCount = tc.editValue;
	tbl.bodyRowCount = tr.editValue;
	tbl.headerRowCount = th.editValue;
	tbl.footerRowCount = tf.editValue;
	tbl.appliedTableStyle = ts[tstyle.selectedIndex];
	if (dlk.checkedState) {
		//外枠の罫線
		tbl.leftBorderStrokeColor  = tbl.topBorderStrokeColor
	  = tbl.rightBorderStrokeColor = tbl.bottomBorderStrokeColor = sc[sc0.selectedIndex];
		tbl.leftBorderStrokeType  = tbl.topBorderStrokeType
	  = tbl.rightBorderStrokeType = tbl.bottomBorderStrokeType = ss[ss0.selectedIndex];
		tbl.leftBorderStrokeWeight  = tbl.topBorderStrokeWeight
	  = tbl.rightBorderStrokeWeight = tbl.bottomBorderStrokeWeight = sw0.editValue * ux[wut.selectedIndex];
		//表内部の罫線
		with (tbl.cells.itemByRange(0, tbl.cells.length - 1) ) {
			innerRowStrokeColor = innerColumnStrokeColor = sc[sc1.selectedIndex];
			innerRowStrokeType = innerColumnStrokeType = ss[ss1.selectedIndex];
			innerRowStrokeWeight = innerColumnStrokeWeight = sw1.editValue * ux[wut.selectedIndex];
		}
		//ヘッダ行と本文行の間------以下のやり方が最適か知らない。試行錯誤の末できたもの
		if (ck2.checkedState == true && th.editValue > 0) {
			for (i = 0 ; i < tbl.columns.length ; i++ ){
				with (tbl.columns[i].cells.itemByRange(th.editValue - 1, th.editValue)) {
					innerRowStrokeColor = sc[sc2.selectedIndex];
					innerRowStrokeType = ss[ss2.selectedIndex];
					innerRowStrokeWeight = sw2.editValue * ux[wut.selectedIndex];
				}
			}
		}
		//フッタ行と本文行の間
		if (ck3.checkedState == true && tf.editValue > 0) {
			for (i = 0 ; i < tbl.columns.length ; i++ ){
				with (tbl.columns[i].cells.itemByRange(th.editValue + tr.editValue - 1, th.editValue + tr.editValue)) {
					innerRowStrokeColor = sc[sc3.selectedIndex];
					innerRowStrokeType = ss[ss3.selectedIndex];
					innerRowStrokeWeight = sw3.editValue * ux[wut.selectedIndex];
				}
			}
		}
		//指定した列
		if (ck4.checkedState == true && ckc.editValue > 0) {
			for (i = 0 ; i < tbl.rows.length ; i++ ){
				with (tbl.rows[i].cells.itemByRange(ckc.editValue - 1, ckc.editValue)) {
					innerColumnStrokeColor = sc[sc4.selectedIndex];
					innerColumnStrokeType = ss[ss4.selectedIndex];
					innerColumnStrokeWeight = sw4.editValue * ux[wut.selectedIndex];
				}
			}
		}
	}
	//終了処理
	dlg.destroy(); //ダイアログを解放
	doc.viewPreferences.horizontalMeasurementUnits = uni[0];
	doc.viewPreferences.verticalMeasurementUnits = uni[1];
	doc.viewPreferences.lineMeasurementUnits = uni[2];
	doc.viewPreferences.textSizeMeasurementUnits = uni[3];
	doc.viewPreferences.typographicMeasurementUnits = uni[4];
}
